/*
Monthly Trading labs
*/

int gi_unused_76;
extern string lbl_ = "RSI/CCI/MOM Scalping";
extern int StopLoss = 25;
extern int TakeProfit = 25;
extern int MagicNumber = 12345;
extern double LotSize = 0.1;
extern string lbl1 = "-- Indicator Settings --";
extern int RSIPeriod = 8;
extern int CCIPeriod = 12;
extern int MOMPeriod = 20;
extern string lbl2 = "-- Breaks --";
extern int MOMLine = 100;
extern int RSILine = 50;
extern int CCIBtmLine = -75;
extern int CCITopLine = 75;
extern string lbl3 = "-- Optimizations -- ";
extern bool UseAllThree = TRUE;
extern bool UseRSIandCCI = TRUE;
extern bool UseRSIandMOM = TRUE;
extern bool ActiveMidBar = TRUE;
int g_ticket_184;
int g_time_188 = -1;
int g_time_192 = -1;
int g_bars_196 = -1;
bool gi_200 = TRUE;

int handleError(int ai_0) {
   bool l_bool_12;
   int l_count_16;
   int li_unused_4 = 1;
   switch (ai_0) {
   case 0:
      return (0);
   case 2:
      Print("System failure. Reboot the computer/check the server");
      gi_unused_76 = 2;
      return (3);
   case 3:
      Print("Error of the logic of the EA");
      gi_unused_76 = 3;
      return (3);
   case 4:
      Print("Trading server is busy. Wait for 2 minutes.");
      Sleep(120000);
      RefreshRates();
      return (2);
   case 6:
      l_bool_12 = FALSE;
      l_count_16 = 0;
      Print("Disconnect ");
      while (!l_bool_12 || l_count_16 > 60) {
         Sleep(10000);
         Print("Connection not restored", 10 * l_count_16, "  seconds passed");
         l_bool_12 = IsConnected();
         if (l_bool_12) {
            Print("Connection restored");
            return (2);
         }
         l_count_16++;
      }
      Print("Connection problems");
      gi_unused_76 = 6;
      return (3);
   case 8:
      Print("Frequent requests");
      gi_unused_76 = 8;
      return (3);
   case 64:
      Print("Account is blocked!");
      gi_unused_76 = 64;
      return (3);
   case 65:
      Print("Wrong account number???");
      gi_unused_76 = 65;
      return (3);
   case 128:
      Print("Waiting of transaction timed out");
      Sleep(60000);
      RefreshRates();
      return (2);
   case 129:
      Print("Wrong price");
      Sleep(7000);
      RefreshRates();
      return (2);
   case 130:
      Print("Wrong stop");
      gi_unused_76 = 130;
      return (3);
   case 131:
      Print("Wrong calculation of trade volume");
      gi_unused_76 = 131;
      return (3);
   case 132:
      Print("Market closed");
      return (2);
   case 134:
      Print("Lack of margin for performing operation");
      gi_unused_76 = 134;
      return (3);
   case 135:
      Print("Prices changed");
      RefreshRates();
      return (2);
   case 136:
      Print("No price!");
      Sleep(5000);
      RefreshRates();
      return (2);
   case 138:
      Print("Requote again!");
      RefreshRates();
      return (2);
   case 139:
      Print("The order is in process. Program glitch");
      gi_unused_76 = 139;
      return (3);
   case 141:
      Print("Too many requests");
      gi_unused_76 = 141;
      return (3);
   case 146:
      Print("Thread is busy");
      while (IsTradeContextBusy()) Sleep(2000);
      return (2);
   case 148:
      Print("Transaction volume too large");
      gi_unused_76 = 148;
      return (3);
   }
   return (0);
}

int init() {
   if (Digits == 5) {
      StopLoss = 10 * StopLoss;
      TakeProfit = 10 * TakeProfit;
   }
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_error_76;
   double l_price_80;
   double l_price_88;
   if (!gi_200) {
      Comment("Haulting Trading! Please Re-Attach To Begin Trading Again...");
      return (0);
   }
   double l_irsi_0 = iRSI(Symbol(), 0, RSIPeriod, PRICE_TYPICAL, 0);
   double l_irsi_8 = iRSI(Symbol(), 0, RSIPeriod, PRICE_TYPICAL, 1);
   double l_irsi_16 = iRSI(Symbol(), 0, RSIPeriod, PRICE_TYPICAL, 2);
   double l_icci_24 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, 0);
   double l_icci_32 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, 1);
   double l_icci_40 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, 2);
   double l_imomentum_48 = iMomentum(Symbol(), 0, MOMPeriod, PRICE_CLOSE, 0);
   double l_imomentum_56 = iMomentum(Symbol(), 0, MOMPeriod, PRICE_CLOSE, 1);
   double l_imomentum_64 = iMomentum(Symbol(), 0, MOMPeriod, PRICE_CLOSE, 2);
   if (totalOrders(MagicNumber) < 1) {
      if (ActiveMidBar == TRUE) {
         if (l_irsi_8 > 50.0 && l_irsi_0 < 50.0 && l_icci_32 > CCIBtmLine && l_icci_24 < CCIBtmLine && l_imomentum_56 > MOMLine && l_imomentum_48 < MOMLine && g_time_188 != Time[0] &&
            UseAllThree == TRUE) {
            l_price_80 = Bid + StopLoss * Point;
            l_price_88 = Bid - TakeProfit * Point;
            if (StopLoss <= 0) l_price_80 = 0;
            if (TakeProfit <= 0) l_price_88 = 0;
            g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
            if (g_ticket_184 < 1) {
               for (int l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                  l_error_76 = GetLastError();
                  Print("Error in putting on order!! -- ", l_error_76);
                  if (handleError(l_error_76) == 3) {
                     Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
                  Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                  Sleep(2000);
                  RefreshRates();
                  l_price_80 = Bid + StopLoss * Point;
                  l_price_88 = Bid - TakeProfit * Point;
                  if (StopLoss <= 0) l_price_80 = 0;
                  if (TakeProfit <= 0) l_price_88 = 0;
                  g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
                  if (g_ticket_184 > 0) break;
               }
               if (g_ticket_184 < 1) {
                  Alert("Could not put on order! Haulting Trading...");
                  gi_200 = FALSE;
                  return (0);
               }
            }
            g_time_188 = Time[0];
            return (0);
         }
         if (l_irsi_8 > 50.0 && l_irsi_0 < 50.0 && l_icci_32 > CCIBtmLine && l_icci_24 < CCIBtmLine && g_time_188 != Time[0] && UseRSIandCCI == TRUE) {
            l_price_80 = Bid + StopLoss * Point;
            l_price_88 = Bid - TakeProfit * Point;
            if (StopLoss <= 0) l_price_80 = 0;
            if (TakeProfit <= 0) l_price_88 = 0;
            g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
            if (g_ticket_184 < 1) {
               for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                  l_error_76 = GetLastError();
                  Print("Error in putting on order!! -- ", l_error_76);
                  if (handleError(l_error_76) == 3) {
                     Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
                  Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                  Sleep(2000);
                  RefreshRates();
                  l_price_80 = Bid + StopLoss * Point;
                  l_price_88 = Bid - TakeProfit * Point;
                  if (StopLoss <= 0) l_price_80 = 0;
                  if (TakeProfit <= 0) l_price_88 = 0;
                  g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
                  if (g_ticket_184 > 0) break;
               }
               if (g_ticket_184 < 1) {
                  Alert("Could not put on order! Haulting Trading...");
                  gi_200 = FALSE;
                  return (0);
               }
            }
            g_time_188 = Time[0];
            return (0);
         }
         if (l_irsi_8 > 50.0 && l_irsi_0 < 50.0 && l_imomentum_56 > MOMLine && l_imomentum_48 < MOMLine && g_time_188 != Time[0] && UseRSIandMOM == TRUE) {
            l_price_80 = Bid + StopLoss * Point;
            l_price_88 = Bid - TakeProfit * Point;
            if (StopLoss <= 0) l_price_80 = 0;
            if (TakeProfit <= 0) l_price_88 = 0;
            g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
            if (g_ticket_184 < 1) {
               for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                  l_error_76 = GetLastError();
                  Print("Error in putting on order!! -- ", l_error_76);
                  if (handleError(l_error_76) == 3) {
                     Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
                  Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                  Sleep(2000);
                  RefreshRates();
                  l_price_80 = Bid + StopLoss * Point;
                  l_price_88 = Bid - TakeProfit * Point;
                  if (StopLoss <= 0) l_price_80 = 0;
                  if (TakeProfit <= 0) l_price_88 = 0;
                  g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
                  if (g_ticket_184 > 0) break;
               }
               if (g_ticket_184 < 1) {
                  Alert("Could not put on order! Haulting Trading...");
                  gi_200 = FALSE;
                  return (0);
               }
            }
            g_time_188 = Time[0];
            return (0);
         }
         if (l_irsi_8 < 50.0 && l_irsi_0 > 50.0 && l_icci_32 < CCITopLine && l_icci_24 > CCITopLine && l_imomentum_56 < MOMLine && l_imomentum_48 > MOMLine && g_time_192 != Time[0] &&
            UseAllThree == TRUE) {
            l_price_80 = Ask - StopLoss * Point;
            l_price_88 = Ask + TakeProfit * Point;
            if (StopLoss <= 0) l_price_80 = 0;
            if (TakeProfit <= 0) l_price_88 = 0;
            g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
            if (g_ticket_184 < 1) {
               for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                  l_error_76 = GetLastError();
                  Print("Error in putting on order!! -- ", l_error_76);
                  if (handleError(l_error_76) == 3) {
                     Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
                  Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                  Sleep(2000);
                  RefreshRates();
                  l_price_80 = Ask - StopLoss * Point;
                  l_price_88 = Ask + TakeProfit * Point;
                  if (StopLoss <= 0) l_price_80 = 0;
                  if (TakeProfit <= 0) l_price_88 = 0;
                  g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
                  if (g_ticket_184 > 0) break;
               }
               if (g_ticket_184 < 1) {
                  Alert("Could not put on order! Haulting Trading...");
                  gi_200 = FALSE;
                  return (0);
               }
            }
            g_time_192 = Time[0];
            return (0);
         }
         if (l_irsi_8 < 50.0 && l_irsi_0 > 50.0 && l_icci_32 < CCITopLine && l_icci_24 > CCITopLine && g_time_192 != Time[0] && UseRSIandCCI == TRUE) {
            l_price_80 = Ask - StopLoss * Point;
            l_price_88 = Ask + TakeProfit * Point;
            if (StopLoss <= 0) l_price_80 = 0;
            if (TakeProfit <= 0) l_price_88 = 0;
            g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
            if (g_ticket_184 < 1) {
               for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                  l_error_76 = GetLastError();
                  Print("Error in putting on order!! -- ", l_error_76);
                  if (handleError(l_error_76) == 3) {
                     Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
                  Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                  Sleep(2000);
                  RefreshRates();
                  l_price_80 = Ask - StopLoss * Point;
                  l_price_88 = Ask + TakeProfit * Point;
                  if (StopLoss <= 0) l_price_80 = 0;
                  if (TakeProfit <= 0) l_price_88 = 0;
                  g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
                  if (g_ticket_184 > 0) break;
               }
               if (g_ticket_184 < 1) {
                  Alert("Could not put on order! Haulting Trading...");
                  gi_200 = FALSE;
                  return (0);
               }
            }
            g_time_192 = Time[0];
            return (0);
         }
         if (l_irsi_8 > 50.0 && l_irsi_0 < 50.0 && l_imomentum_56 < MOMLine && l_imomentum_48 > MOMLine && g_time_192 != Time[0] && UseRSIandMOM == TRUE) {
            l_price_80 = Ask - StopLoss * Point;
            l_price_88 = Ask + TakeProfit * Point;
            if (StopLoss <= 0) l_price_80 = 0;
            if (TakeProfit <= 0) l_price_88 = 0;
            g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
            if (g_ticket_184 < 1) {
               for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                  l_error_76 = GetLastError();
                  Print("Error in putting on order!! -- ", l_error_76);
                  if (handleError(l_error_76) == 3) {
                     Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
                  Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                  Sleep(2000);
                  RefreshRates();
                  l_price_80 = Ask - StopLoss * Point;
                  l_price_88 = Ask + TakeProfit * Point;
                  if (StopLoss <= 0) l_price_80 = 0;
                  if (TakeProfit <= 0) l_price_88 = 0;
                  g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
                  if (g_ticket_184 > 0) break;
               }
               if (g_ticket_184 < 1) {
                  Alert("Could not put on order! Haulting Trading...");
                  gi_200 = FALSE;
                  return (0);
               }
            }
            g_time_192 = Time[0];
            return (0);
         }
      } else {
         if (g_bars_196 != Bars) {
            g_bars_196 = Bars;
            if (l_irsi_16 > 50.0 && l_irsi_8 < 50.0 && l_icci_40 > CCIBtmLine && l_icci_32 < CCIBtmLine && l_imomentum_64 > MOMLine && l_imomentum_56 < MOMLine && g_time_188 != Time[0] &&
               UseAllThree == TRUE) {
               l_price_80 = Bid + StopLoss * Point;
               l_price_88 = Bid - TakeProfit * Point;
               if (StopLoss <= 0) l_price_80 = 0;
               if (TakeProfit <= 0) l_price_88 = 0;
               g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
               if (g_ticket_184 < 1) {
                  for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                     l_error_76 = GetLastError();
                     Print("Error in putting on order!! -- ", l_error_76);
                     if (handleError(l_error_76) == 3) {
                        Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                        gi_200 = FALSE;
                        return (0);
                     }
                     Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                     Sleep(2000);
                     RefreshRates();
                     l_price_80 = Bid + StopLoss * Point;
                     l_price_88 = Bid - TakeProfit * Point;
                     if (StopLoss <= 0) l_price_80 = 0;
                     if (TakeProfit <= 0) l_price_88 = 0;
                     g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
                     if (g_ticket_184 > 0) break;
                  }
                  if (g_ticket_184 < 1) {
                     Alert("Could not put on order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
               }
               g_time_188 = Time[0];
               return (0);
            }
            if (l_irsi_16 > 50.0 && l_irsi_8 < 50.0 && l_icci_40 > CCIBtmLine && l_icci_32 < CCIBtmLine && g_time_188 != Time[0] && UseRSIandCCI == TRUE) {
               l_price_80 = Bid + StopLoss * Point;
               l_price_88 = Bid - TakeProfit * Point;
               if (StopLoss <= 0) l_price_80 = 0;
               if (TakeProfit <= 0) l_price_88 = 0;
               g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
               if (g_ticket_184 < 1) {
                  for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                     l_error_76 = GetLastError();
                     Print("Error in putting on order!! -- ", l_error_76);
                     if (handleError(l_error_76) == 3) {
                        Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                        gi_200 = FALSE;
                        return (0);
                     }
                     Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                     Sleep(2000);
                     RefreshRates();
                     l_price_80 = Bid + StopLoss * Point;
                     l_price_88 = Bid - TakeProfit * Point;
                     if (StopLoss <= 0) l_price_80 = 0;
                     if (TakeProfit <= 0) l_price_88 = 0;
                     g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
                     if (g_ticket_184 > 0) break;
                  }
                  if (g_ticket_184 < 1) {
                     Alert("Could not put on order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
               }
               g_time_188 = Time[0];
               return (0);
            }
            if (l_irsi_16 > 50.0 && l_irsi_8 < 50.0 && l_imomentum_64 > MOMLine && l_imomentum_56 < MOMLine && g_time_188 != Time[0] && UseRSIandMOM == TRUE) {
               l_price_80 = Bid + StopLoss * Point;
               l_price_88 = Bid - TakeProfit * Point;
               if (StopLoss <= 0) l_price_80 = 0;
               if (TakeProfit <= 0) l_price_88 = 0;
               g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
               if (g_ticket_184 < 1) {
                  for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                     l_error_76 = GetLastError();
                     Print("Error in putting on order!! -- ", l_error_76);
                     if (handleError(l_error_76) == 3) {
                        Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                        gi_200 = FALSE;
                        return (0);
                     }
                     Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                     Sleep(2000);
                     RefreshRates();
                     l_price_80 = Bid + StopLoss * Point;
                     l_price_88 = Bid - TakeProfit * Point;
                     if (StopLoss <= 0) l_price_80 = 0;
                     if (TakeProfit <= 0) l_price_88 = 0;
                     g_ticket_184 = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
                     if (g_ticket_184 > 0) break;
                  }
                  if (g_ticket_184 < 1) {
                     Alert("Could not put on order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
               }
               g_time_188 = Time[0];
               return (0);
            }
            if (l_irsi_16 < 50.0 && l_irsi_8 > 50.0 && l_icci_40 < CCITopLine && l_icci_32 > CCITopLine && l_imomentum_64 < MOMLine && l_imomentum_56 > MOMLine && g_time_192 != Time[0] &&
               UseAllThree == TRUE) {
               l_price_80 = Ask - StopLoss * Point;
               l_price_88 = Ask + TakeProfit * Point;
               if (StopLoss <= 0) l_price_80 = 0;
               if (TakeProfit <= 0) l_price_88 = 0;
               g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
               if (g_ticket_184 < 1) {
                  for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                     l_error_76 = GetLastError();
                     Print("Error in putting on order!! -- ", l_error_76);
                     if (handleError(l_error_76) == 3) {
                        Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                        gi_200 = FALSE;
                        return (0);
                     }
                     Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                     Sleep(2000);
                     RefreshRates();
                     l_price_80 = Ask - StopLoss * Point;
                     l_price_88 = Ask + TakeProfit * Point;
                     if (StopLoss <= 0) l_price_80 = 0;
                     if (TakeProfit <= 0) l_price_88 = 0;
                     g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Blue);
                     if (g_ticket_184 > 0) break;
                  }
                  if (g_ticket_184 < 1) {
                     Alert("Could not put on order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
               }
               g_time_192 = Time[0];
               return (0);
            }
            if (l_irsi_16 < 50.0 && l_irsi_8 > 50.0 && l_icci_40 < CCITopLine && l_icci_32 > CCITopLine && g_time_192 != Time[0] && UseRSIandCCI == TRUE) {
               l_price_80 = Ask - StopLoss * Point;
               l_price_88 = Ask + TakeProfit * Point;
               if (StopLoss <= 0) l_price_80 = 0;
               if (TakeProfit <= 0) l_price_88 = 0;
               g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
               if (g_ticket_184 < 1) {
                  for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                     l_error_76 = GetLastError();
                     Print("Error in putting on order!! -- ", l_error_76);
                     if (handleError(l_error_76) == 3) {
                        Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                        gi_200 = FALSE;
                        return (0);
                     }
                     Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                     Sleep(2000);
                     RefreshRates();
                     l_price_80 = Ask - StopLoss * Point;
                     l_price_88 = Ask + TakeProfit * Point;
                     if (StopLoss <= 0) l_price_80 = 0;
                     if (TakeProfit <= 0) l_price_88 = 0;
                     g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, White);
                     if (g_ticket_184 > 0) break;
                  }
                  if (g_ticket_184 < 1) {
                     Alert("Could not put on order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
               }
               g_time_192 = Time[0];
               return (0);
            }
            if (l_irsi_16 > 50.0 && l_irsi_8 < 50.0 && l_imomentum_64 < MOMLine && l_imomentum_56 > MOMLine && g_time_192 != Time[0] && UseRSIandMOM == TRUE) {
               l_price_80 = Ask - StopLoss * Point;
               l_price_88 = Ask + TakeProfit * Point;
               if (StopLoss <= 0) l_price_80 = 0;
               if (TakeProfit <= 0) l_price_88 = 0;
               g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
               if (g_ticket_184 < 1) {
                  for (l_count_72 = 0; l_count_72 < 10; l_count_72++) {
                     l_error_76 = GetLastError();
                     Print("Error in putting on order!! -- ", l_error_76);
                     if (handleError(l_error_76) == 3) {
                        Alert("Fatal Error -- Can Not Put On Order! Haulting Trading...");
                        gi_200 = FALSE;
                        return (0);
                     }
                     Print("Saveable error..trying again..(#" + l_count_72 + " of 10");
                     Sleep(2000);
                     RefreshRates();
                     l_price_80 = Ask - StopLoss * Point;
                     l_price_88 = Ask + TakeProfit * Point;
                     if (StopLoss <= 0) l_price_80 = 0;
                     if (TakeProfit <= 0) l_price_88 = 0;
                     g_ticket_184 = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, l_price_80, l_price_88, 0, MagicNumber, 0, Orange);
                     if (g_ticket_184 > 0) break;
                  }
                  if (g_ticket_184 < 1) {
                     Alert("Could not put on order! Haulting Trading...");
                     gi_200 = FALSE;
                     return (0);
                  }
               }
               g_time_192 = Time[0];
               return (0);
            }
         }
      }
   }
   return (0);
}

int totalOrders(int ai_unused_0) {
   int l_count_4 = 0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol()) l_count_4++;
   }
   return (l_count_4);
}